JSON
Enhancers

JSON
Enhancers is a Drupal module that provides a field enhancer for JSON
. This particular module includes the ConvertLinkEnhancer plugin, which transforms embedded entity references or relative URLs into absolute URLs in the JSON
output.
Features

    Converts relative URLs to absolute URLs.
    Processes entity references (e.g., nodes) to generate canonical URLs.
    Fully compatible with Drupal 10 and 11.
    Extensible and customizable JSON
    field enhancement system.

Requirements

    Drupal Core: 10.x or 11.x
    JSON Module: Enabled
    JSON Extras Module: Installed and configured

Installation

   Download the module using Composer:

    composer require drupal/jsonapi_enhancers

Enable the module:

    drush en jsonapi_enhancers

Clear the caches:

    drush cr

Configuration

This module works out of the box. To use the ConvertLinkEnhancer, you must configure your JSON
resource fields using the JSON
Extras module.
Steps:

    Navigate to Configuration → JSON Extras.
    Edit the resource where you want to apply the ConvertLinkEnhancer.
    Add the Convert to Link enhancer to the desired field.
    Save the configuration and clear caches.

Example Use Case

Suppose your JSON
response contains a field with a relative URL or an entity reference like:

{
  "uri": "entity:node/123"
}

After applying the ConvertLinkEnhancer, the response will transform it into an absolute URL:

{
  "uri": "https://example.com/node/123"
}

Code Overview
Plugin: ConvertLinkEnhancer

Located at src/Plugin/jsonapi/FieldEnhancer/ConvertLinkEnhancer.php, this plugin:

    Processes JSON
    output fields.
    Transforms relative URLs (/path) into absolute URLs (https://example.com/path).
    Converts entity references (entity:node/123) to canonical URLs.

Extending the Module

You can create additional field enhancers by extending \Drupal\jsonapi_extras\Plugin\ResourceFieldEnhancerBase and registering the new plugin with the appropriate annotation.
Developer Notes

    Namespace: Drupal\jsonapi_enhancers
    Key Classes:
        ConvertLinkEnhancer: Main plugin for URL transformation.

Contributing

Contributions are welcome! Please:

    Fork the repository.
    Create a feature branch.
    Submit a pull request with clear descriptions.

License

This project is licensed under the GPLv2 or later.
